import sys
from braid import Braid, braid2hex, hex2braid, str2hex
from network import ServerSocket
from peer import ServerPeer
from daemon import Daemon

class AuthServer(Daemon):
    
    def __init__(self):
        Daemon.__init__(self, '/tmp/authserver.pid',user='crypto300')
        
        # public known braid
        raw_K = '0D1214040108060F050C0E0207030A151009000B1311'

        # import public known braid
        K = hex2braid(raw_K)
        # create server peer instance
        peer = ServerPeer(K)
        
        # bind peer instance to a socket (and set up a single allowed public key)
        self.s = ServerSocket(peer,allowed_pubkeys=['0F0C11040108060B05150E1000090A030D1312140207'])
        
    def run(self):
        self.s.serve()

if __name__ == '__main__':
    if len(sys.argv)==2:
        as = AuthServer()
        action = sys.argv[1]
        if action=='start':
            print 'Starting AuthServer daemon ...'
            as.start()
            print 'AuthServer daemon started'
        elif action=='stop':
            print 'Stopping AuthServer daemon ...'
            as.stop()
            print 'AuthServer daemon stopped'
        elif action=='restart':
            print 'Restating AuthServer daemon ...'
            as.restart()
            print 'AuthServer daemon restarted'
        else:
            print 'Unknown parameter'